#ifndef __STDLIB_H
	#include <stdlib.h>
#endif
#ifndef __STRING_H
	#include <string.h>
#endif
#ifndef __IOSTREAM_H
	#include <iostream.h>
#endif
#ifndef __FSTREAM_H
	#include <fstream.h>
#endif
#ifndef __CONIO_H
	#include <conio.h>
#endif
#ifndef __TIME_H
	#include <time.h>
#endif


enum BOOL {TRUE=0,FALSE=-1};

char *Beginning_of_8_3_File_Name(char *pString);
void Generate_Translation_Table(char Table[256]);
BOOL Convert_File(char *File_Name, char Table[256]);
void Change_Extension_To(char *pExtension,char File_Name[8+1+3+1]);

BOOL main(int argc, char *argv[])
   {
   randomize();
   char Trans_Table[256];
   if (argc != 2)
      {
      cerr<<"\n\t Wrong Number of arguments";
      exit(FALSE);
      }
   Generate_Translation_Table(Trans_Table);
   Convert_File(argv[1],Trans_Table);
   return TRUE;
   }

void Generate_Translation_Table(char Table[256])
   {
   //Yes, I know, terribly inefficient...
   short Inverse_Array[26];
   //Inverse_Array is an array that keeps track of which cyphertext
   //characters are already used
   memset(Inverse_Array,0,26);
   for(int plain_char=0;plain_char<256;plain_char++)
      Table[plain_char] = plain_char;
   for(plain_char='a'; plain_char<='z'; plain_char++)
      {
      int i = random(26-(plain_char-'a'))+1;
	   //random numbers from 1..26 to 1..1
      for(int n=0;i>0;i--,n++)
	 {
	 while(Inverse_Array[n]==1)
	    n++;
	 if (i==1)
	    {
	    Table['a'+n] = plain_char;
	    Table['A'+n] = plain_char+'A'-'a';
	    Inverse_Array[n] = 1;
	    }
	 }
      }
   }

char *Beginning_of_8_3_File_Name(char *pString)
   {
   char *pBeginning = pString+strlen(pString);
   while(*(pBeginning-1) != '\\'&& *(pBeginning-1) != ':'
		      && pBeginning > pString)
      pBeginning--;
   return pBeginning;
   }

void Change_Extension_To(char pExtension[3],char File_Name[8+1+3+1])
   {
   for(int n=0; n<strlen(File_Name);n++)
      {
      if(File_Name[n] == ':' || File_Name[n] == '\\')
	 {
	 cerr<<"\nError in input to Change_Extension_To()";
	 exit(FALSE);
	 }
      if(File_Name[n] == '.')
	 {
	 n++;
	 break;
	 }
      }
   strcpy((File_Name+n),pExtension);
   }

BOOL Convert_File(char *File_Name, char Table[256])
   {
   ifstream InFile;
   ofstream OutFile;
   InFile.open(File_Name, ios::binary|ios::in|ios::nocreate);
   if(InFile.bad())
      {
      cerr<<"\nAn error occurred while openning "<<File_Name;
      return FALSE;
      }
   char OF_NAME[8+1+3+1];
   memset(OF_NAME,0,8+1+3+1);
   strcpy(OF_NAME,Beginning_of_8_3_File_Name(File_Name));
   Change_Extension_To("CIP",OF_NAME);
   OutFile.open(OF_NAME, ios::binary|ios::noreplace|ios::out);
   if(OutFile.bad())
      {
      cerr<<"\nAn error occurred while openning "<<OF_NAME;
      cout<<"\nThis file probably exists.  Overwrite [y/n]?";
      char ans='h';
      for(;;)
	 {
	 cin>>ans;
	 if(ans=='y'||ans=='Y')
	    break;
	 if(ans=='n'||ans=='N')
	    return FALSE;
	 }
      OutFile.open(OF_NAME, ios::binary|ios::out);
      if(OutFile.bad())
	 {
	 cerr<<"\nAn error occurred while openning "<<OF_NAME;
	 return FALSE;
	 }
      }
   int input;
   input = InFile.get();
   while(input != EOF)
      {
      OutFile.put(Table[input]);
      input = InFile.get();
      }
   return TRUE;
   }

